/*
 * LPGPL v2 or later
 * (C) Neil Jagdish Patel <njpatel@gmail.com>
 */

using GLib;
using Gtk;
using Dee;

using Gwibber;

uint MAX_ROWS = 100;

Dee.Model
create_model ()
{
  var names = new string[10] { "Neil Jagdish Patel",
                               "Ken Van Dine",
                               "Ryan Paul",
                               "Paul Hummer",
                               "Gaurav Patel",
                               "Evan",
                               "Alexander Sack",
                               "Jorge Castro",
                               "Gustavo Niemeyer",
                               "Ted Gould"};
  var messages = new string[10] {
      "Adding unit tests to the Unity panel service. Mixing GTester + C++ is interesting, definitely not as bad as I thought it would be.",
      "The police officer that was shot in this news story <a href='http://is.gd/hmV87'>http://is.gd/hmV87</a> is a dear friend of mine, everyone send good vibes his way",
      "RT <a href='@webmink'>@webmink</a>: RT <a href='@BoingBoing'>@BoingBoing</a>: Odds of cancer from TSA scanners about the same as terrorist blowing up your plane <a href='http://bit.ly/9JKiPb'>http://bit.ly/9JKiPb</a>",
      "It's been so long since I've seen my wife that I enjoyed the TSA pat down a bit too much...",
      "Happy belated birthday <a href='@Whatleydude'>@Whatleydude</a>!",
      "There are far too many Roman columns in this part of town.",
      "back to basics: sunday house cleaning - bah!",
      "Goddamnit Smallville, it's the last season. Be relevant and not so ... sandbaggy. This \"mutant registration act\" thing is overdone.",
      "♺ <a href='@rbp'>@rbp</a>: RT <a href='@ThePSF'>@ThePSF</a> rt <a href='@voidspace'>@voidspace</a>: Here is the list of Python bugs closed (so far) during the bug weekend: Way to go!> <a href='http://goo.gl/V8cJu'>http://goo.gl/V8cJu</a>",
      "<a href='@bratschegnome'>@bratschegnome</a>: Cool! Fortunately Google knows more about bikes than I do :)"};

  Dee.Model model;
    
  model = new Dee.SequenceModel (6,
                                 typeof (uint),
                                 typeof (string),
                                 typeof (string),
                                 typeof (uint),
                                 typeof (string),
                                 typeof (string));
  
  for (uint i = 0; i < MAX_ROWS; i++)
    {
      model.append (0, i,
                    1, "Twitter",
                    2, names[i % 10],
                    3, 0,
                    4, messages[i % 10],
                    5, "stock_person",
                    -1);
    }

  return model.ref () as Dee.Model;
}

int
main (string[] args)
{
  Gtk.Window window;
  StreamView view;
  Dee.Model  model;

  Gtk.init (ref args);

  window = new Gtk.Window ();
  window.resize (350, 600);
  window.set_colormap (Gdk.Screen.get_default ().get_rgba_colormap ());
  window.set_app_paintable (true);
  window.realize ();
  window.window.set_back_pixmap (null, false);

  window.expose_event.connect ((event) => {
    var cr = Gdk.cairo_create (window.window);

    cr.set_operator (Cairo.Operator.CLEAR);
    cr.paint ();
    
    cr.set_source_rgba (242/255.0f, 241/255.0f, 240/255.0f, 0.85f);
    cr.set_operator (Cairo.Operator.OVER);
    cr.paint ();
    return false;
  });
  
  view = new StreamView ();
  view.set_size_request (350, 600);
  window.add (view);

  /* This can be a Dee.SharedModel too */
  model = create_model ();
  view.model = model;

  window.show_all ();
  
  Gtk.main ();

  return 0;
}
